# SoNormalBinding Class Reference
[Nodes]

`#include <Inventor/nodes/SoNormalBinding.h>`

Inheritance diagram for SoNormalBinding:

List of all members.

## Detailed Description

The SoNormalBinding class is a node for specifying normal vector bindings.

Use nodes of this type to specify how to map normal vectors from SoNormal nodes in the scene graph to shape nodes.

## Public Types

enum

Binding {
OVERALL = SoNormalBindingElement::OVERALL, PER_PART = SoNormalBindingElement::PER_PART, PER_PART_INDEXED = SoNormalBindingElement::PER_PART_INDEXED, PER_FACE = SoNormalBindingElement::PER_FACE,
PER_FACE_INDEXED = SoNormalBindingElement::PER_FACE_INDEXED, PER_VERTEX = SoNormalBindingElement::PER_VERTEX, PER_VERTEX_INDEXED = SoNormalBindingElement::PER_VERTEX_INDEXED, DEFAULT = PER_VERTEX_INDEXED,
NONE = PER_VERTEX_INDEXED
}

## Public Member Functions

| SoNormalBinding (void)
virtual void | doAction (SoAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | pick (SoPickAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)

## Static Public Member Functions

void | initClass (void)

## Public Attributes

SoSFEnum | value

## Protected Member Functions

virtual | ~SoNormalBinding ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)

## Member Enumeration Documentation

enum SoNormalBinding::Binding

| Enumeration of available types of mappings. See documentation of SoMaterialBinding node for explanation of the different values. Note that SoNormalBinding::DEFAULT and SoNormalBinding::NONE has been obsoleted and are both mapped to SoNormalBinding::PER_VERTEX_INDEXED.

## Constructor & Destructor Documentation

SoNormalBinding::SoNormalBinding | ( | void |  | ) |

| Constructor.

SoNormalBinding::~SoNormalBinding | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoNormalBinding::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoNode.

void SoNormalBinding::doAction | ( | SoAction * | action | ) | `[virtual]`

| This function performs the typical operation of a node for any action. Reimplemented from SoNode.

void SoNormalBinding::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoNode.

void SoNormalBinding::callback | ( | SoCallbackAction * | action | ) | `[virtual]`

| Action method for SoCallbackAction. Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph. Reimplemented from SoNode.

void SoNormalBinding::pick | ( | SoPickAction * | action | ) | `[virtual]`

| Action method for SoPickAction. Does common processing for SoPickAction action instances. Reimplemented from SoNode.

void SoNormalBinding::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) | `[virtual]`

| Action method for the SoGetPrimitiveCountAction. Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action. Nodes influencing how geometry nodes calculates their primitive count also overrides this method to change the relevant state variables. Reimplemented from SoNode.

SbBool SoNormalBinding::readInstance | ( | SoInput * | in,
|  | unsigned short | flags
| ) | `[protected, virtual]`

This method is mainly intended for internal use during file import operations.

It reads a definition of an instance from the input stream in. The input stream state points to the start of a serialized / persistant representation of an instance of this class type.

`TRUE` or `FALSE` is returned, depending on if the instantiation and configuration of the new object of this class type went ok or not. The import process should be robust and handle corrupted input streams by returning `FALSE`.

flags is used internally during binary import when reading user extension nodes, group nodes or engines.

Reimplemented from SoNode.

## Member Data Documentation

SoSFEnum SoNormalBinding::value

| The normal binding to use for subsequent shape nodes in the scene graph.

The documentation for this class was generated from the following files:

- SoNormalBinding.h
- SoNormalBinding.cpp